# kbuild manual url:
# https://www.kernel.org/doc/html/latest/kbuild/makefiles.html#userspace-program-support

# default env setting
BUILD_DIR := build
SRC_DIR := src
INC_DIR := include
LIB_DIR := lib
KBUILD_DIR := kbuild

# user setting
clear-ptn-seq := '*~' "\#*\#"

ifndef T
build-seq := core db net test  #build targets sequentialy
test-seq := $(addprefix _test_, $(filter-out test, $(build-seq)))
else
build-seq := $(T)
test-seq := $(addprefix _test_, $(filter-out test, $(build-seq)))
endif

KBUILD_VERBOSE := 1
export KBUILD_DIR KBUILD_VERBOSE
export SRC_DIR INC_DIR LIB_DIR

default:  _build _test 

$(build-seq):
	cp $(KBUILD_DIR)/KMakefile .
	cd $(BUILD_DIR) && make -C ../ -f KMakefile T=$@ O=`pwd` -j
	cp $(BUILD_DIR)/$@/*.a $(LIB_DIR)/ 2>/dev/null || :
	cp $(BUILD_DIR)/$@/*.so $(LIB_DIR)/ 2>/dev/null || :
_build_init:
	mkdir -p $(BUILD_DIR) $(LIB_DIR)
_build: _build_init $(build-seq)
	rm KMakefile
$(test-seq):
	cd $(BUILD_DIR)/test
	&& LD_LIBRARY_PATH=../../lib ./$(patsubst _%,%,$@)
_test: $(test-seq)
	@:
$(clear-ptn-seq):
	find . -type f -name $@ -exec rm {} +
clear: $(clear-ptn-seq)

clean:
	rm -rf $(BUILD_DIR)
	rm -rf $(LIB_DIR)/*.a

PHONY += clear clean
.PHONY: $(PHONY)


push_lib:
	cp lib/* ../illya/lib
